.include "m32def.inc"

.def flags = R2
.def cnt   = R3
.def temp  = R16
.def RezL  = R17
.def RezH  = R18
.def pos   = R19
.def tmpL  = R20
.def tmpH  = R21
 

.dseg	// segmentul de date
	Display: .Byte 4

.cseg
.org	0x0000
	rjmp	RESET	; Salt neconditionat

.org	INT0addr	; External Interrupt0 Vector Address
	reti
.org	INT1addr	; External Interrupt1 Vector Address
	reti
.org	INT2addr	; External Interrupt2 Vector Address
	reti
.org	OC2addr	    ; Output Compare2 Interrupt Vector Address
	reti 
.org	OVF2addr	; Overflow2 Interrupt Vector Address
	reti
.org	ICP1addr	; Input Capture1 Interrupt Vector Address
	reti
.org	OC1Aaddr	; Output Compare1A Interrupt Vector Address
	reti
.org	OC1Baddr	; Output Compare1B Interrupt Vector Address
	reti
.org	OVF1addr	; Overflow1 Interrupt Vector Address
	reti
.org	OC0addr	    ; Output Compare0 Interrupt Vector Address
	RJMP Display_Next
.org	OVF0addr	; Overflow0 Interrupt Vector Address
	reti
.org	SPIaddr	     ; SPI Interrupt Vector Address
	reti
.org	URXCaddr	; USART Receive Complete Interrupt Vector Address
	reti
.org	UDREaddr	; USART Data Register Empty Interrupt Vector Address
	reti
.org	UTXCaddr	; USART Transmit Complete Interrupt Vector Address
	reti

.org	ADCCaddr	; ADC Interrupt Vector Address
	rjmp End_Conversion

.org	ERDYaddr	; EEPROM Interrupt Vector Address
	reti
.org	ACIaddr 	; Analog Comparator Interrupt Vector Address
	reti
.org    TWIaddr   ; Irq. vector address for Two-Wire Interface
	reti
.org	SPMRaddr	; Store Program Memory Ready Interrupt Vector Address
	reti

RESET:	 
    ldi temp, Low(RAMEND) 
	out SPL, temp
	ldi temp, High(RAMEND) 
	out SPH, temp
 
	CLR temp			; resetam registru temp
	out DDRA,temp		; init as input
	out DDRC,temp

	ldi temp,0x0f
	out DDRB, temp

	SER temp
	out DDRD,temp		; set as output
	

	ldi temp, 156
	out OCR0, temp
	ldi temp,(1<<WGM01)|(0<<WGM00)|(1<<CS02)|(1<<CS00)  ; setam timerul 0 in mod fast CTC cu predivizor 1:1024
	out TCCR0, temp
	ldi temp, (1<<OCIE0)
	out TIMSK, temp	

	ldi temp, (1<<ADTS1)|(1<<ADTS0)
	out SFIOR, temp
	ldi temp, (1<<REFS0)| 1  ; setam referinta la ADC, AVCC si canalul 0
	out ADMUX, temp
	ldi temp, (1<<ADEN)|(1<<ADIE)|(1<<ADATE)|(1<<ADSC)|(1<<ADPS2)|(1<<ADPS1)  ;activam convertorul si lansam conversia
	out ADCSRA, temp
	
	SEI ; validam intreruperile

MAIN: ; programul principal
	 RJMP MAIN




//--------------------------------------------------------------------
Display_Next:
	in flags,SREG
	push temp
	
	ldi temp, 0x0F
	out PORTB,temp
	ld temp, X+
	out PORTD,temp
	out PORTB, pos
	ASR pos
	BRCS end_display
	ldi pos,~(1<<3)
	ldi XL,Low(Display)
	ldi XH,High(Display)


end_display:
	pop temp
	out SREG,flags
	RETI


End_Conversion:    ;Subrutina ce se va apela la sfirs conv. de la ADC
	 in flags, SREG   ; salvam temp. reg. de fanioane
	 push temp

	 in temp, ADMUX
	 andi temp, 0x1F
	 cpi temp, 0   ; testam adresa canalului, salt daca bitul 0 va fi in 0
	 brne  Chanel1
	     
	 in tmpL, ADCL     ; incarcam rez. conversiei
	 in tmpH, ADCH

	 SBI ADMUX, 0
	 SBI ADCSRA, ADSC   ; pornim o noua conversie
      
	 pop temp
	 out SREG, flags   ; restabilim fanioanele
	 RETI

	Chanel1:
//	ldi RezL, Low(4537) // pentru test
//	ldi RezH, High(4537)

//*
     in RezL, ADCL	// rezultatul conversiei de la Intrarea ADC1
	 in RezH, ADCH

	 add RezL, tmpL	// adunam rezultatul conversiei de la Intrarea ADC0
	 adc RezH, tmpH
	 
//*/
	 RCALL Convert

	 cbi ADMUX, 0   ;resetam canalul 1
	 sbi ADCSRA, ADSC   ; lansam o noua conversie

	 pop temp
	 out SREG, flags ;restabilim fanioanele
	 RETI


// subrutina de conversie din binar in zecimal (coduri 7-SEGM)
Convert:
	push tmpL
	push tmpH

// Divide by 10 000
	CLR cnt
	ldi tmpL, Low(10000)
	ldi tmpH, High(10000)
zeceMii:
	cp RezL, tmpL
	cpc rezH, tmpH
	brlo end_zeceMii
	sub RezL,tmpL			; scadem 10000
	sbc RezH,tmpH
	inc cnt
	RJMP zeceMii

end_zeceMii:
	ldi ZL, low(CodeTable*2)
	ldi ZH, high(CodeTable*2)

	add ZL, cnt
	clr cnt
	adc ZH,cnt
	lpm tmpl,Z
//STS Display+4, tmpL  	//nu folosim cifra

// divide by 1000
	CLR cnt
	ldi tmpL, Low(1000)
	ldi tmpH, High(1000)
Mie:
	cp RezL, tmpL
	cpc rezH, tmpH
	brlo end_Mie
	sub RezL,tmpL
	sbc RezH,tmpH
	inc cnt
	RJMP Mie

end_Mie:
	ldi ZL, low(CodeTable*2)
	ldi ZH, high(CodeTable*2)

	add ZL, cnt
	clr cnt
	adc ZH,cnt
	lpm tmpl,Z
	STS Display+3, tmpL

// divide by 100
	CLR cnt
	ldi tmpL, Low(100)
	ldi tmpH, High(100)
Sute:
	cp RezL, tmpL
	cpc rezH, tmpH
	brlo end_Sute
	sub RezL,tmpL
	sbc RezH,tmpH
	inc cnt
	RJMP Sute

end_Sute:
	ldi ZL, low(CodeTable*2)
	ldi ZH, high(CodeTable*2)

	add ZL, cnt
	clr cnt
	adc ZH,cnt
	lpm tmpl,Z
	STS Display+2, tmpL


// divide by 10
	CLR cnt
	ldi tmpL, Low(10)
	ldi tmpH, High(10)
Zeci:
	cp RezL, tmpL
	cpc rezH, tmpH
	brlo end_Zeci
	sub RezL,tmpL
	sbc RezH,tmpH
	inc cnt
	RJMP Zeci

end_Zeci:
	ldi ZL, low(CodeTable*2)
	ldi ZH, high(CodeTable*2)

	add ZL, cnt
	clr cnt
	adc ZH,cnt
	lpm tmpl,Z
	STS Display+1, tmpL

// Ramin unitatile
	ldi ZL, Low(codeTable*2)
	ldi ZH, High(codeTable*2)
	add ZL, RezL
	adc ZH, RezH
	lpm tmpL, Z
	STS Display,tmpL

	pop tmpH
	pop tmpL
	RET

// Tabelul cu coduri pentru display 7-SEG (1, 2, 3...9)
CodeTable: .dB 0x3F, 0x06 , 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F
